unit Unit2; // data

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,                 Unit3;

type
  { TFside }
  Tmain = class(TForm)
  private
    { private declarations }
  public
    { public declarations }
    procedure constructData;
    procedure addSoil(map,field,soil:Integer);
    function giveRessource(ressource:Tressource;ammount:integer):Tres_ammount;
  end;

var
  i:integer;

implementation

procedure Tmain.constructData;
begin
  // Ressourcelist  [<Gold> <Food> <Material> <Gem Stone>]
  setLength(RessourceList,4);

  i:=0; // Gold (1)
  RessourceList[i].Name:='Gold';

  i:=1; // Food (2)
  RessourceList[i].Name:='Food';

  i:=2; // Material (3)
  RessourceList[i].Name:='Material';

  i:=3; // Gem Stone (4)
  RessourceList[i].Name:='Gem Stone';

// SoilList

  setLength(SoilList,11);
  i:=0; // meadow (1)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Food';
    SoilList[i].Clearing_Boni[0].Value:=200;
  SoilList[i].Clearing_Result:='Desert';
  SoilList[i].Food_M:=25;
  SoilList[i].GemStone_M:=0;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=0;
  SoilList[i].Name:='Meadow';
  i:=1; // hill (2)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Material';
    SoilList[i].Clearing_Boni[0].Value:=200;
  SoilList[i].Clearing_Result:='Meadow';
  SoilList[i].Food_M:=0;
  SoilList[i].GemStone_M:=0;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=0;
  SoilList[i].Name:='Hill';
  i:=2; // acre (3)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Food';
    SoilList[i].Clearing_Boni[0].Value:=600;
  SoilList[i].Clearing_Result:='Meadow';
  SoilList[i].Food_M:=100;
  SoilList[i].GemStone_M:=0;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=0;
  SoilList[i].Name:='Acre';
  i:=3; // forest (4)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Material';
    SoilList[i].Clearing_Boni[0].Value:=400;
  SoilList[i].Clearing_Result:='Meadow';
  SoilList[i].Food_M:=0;
  SoilList[i].GemStone_M:=0;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=50;
  SoilList[i].Name:='Forest';
  i:=4; // fertile forest (5)
  SetLength(SoilList[i].Clearing_Boni, 2);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Material';
    SoilList[i].Clearing_Boni[0].Value:=400;
    SoilList[i].Clearing_Boni[1].Ressource.Name:='Food';
    SoilList[i].Clearing_Boni[1].Value:=300;
  SoilList[i].Clearing_Result:='Acre';
  SoilList[i].Food_M:=75;
  SoilList[i].GemStone_M:=0;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=25;
  SoilList[i].Name:='Fertile Forest';
  i:=5; // stone deposit (6)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Material';
    SoilList[i].Clearing_Boni[0].Value:=600;
  SoilList[i].Clearing_Result:='Hill';
  SoilList[i].Food_M:=0;
  SoilList[i].GemStone_M:=25;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=100;
  SoilList[i].Name:='Stone Deposit';
  i:=6; // gold deposit (7)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Gold';
    SoilList[i].Clearing_Boni[0].Value:=600;
  SoilList[i].Clearing_Result:='Hill';
  SoilList[i].Food_M:=0;
  SoilList[i].GemStone_M:=50;
  SoilList[i].Gold_M:=100;
  SoilList[i].Material_M:=0;
  SoilList[i].Name:='Gold Deposit';
  i:=7; // gem stone deposit (8)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Gem Stone';
    SoilList[i].Clearing_Boni[0].Value:=600;
  SoilList[i].Clearing_Result:='Hill';
  SoilList[i].Food_M:=0;
  SoilList[i].GemStone_M:=100;
  SoilList[i].Gold_M:=25;
  SoilList[i].Material_M:=25;
  SoilList[i].Name:='GemStone Deposit';
  i:=8; // swamp (9)
  SetLength(SoilList[i].Clearing_Boni, 1);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Food';
    SoilList[i].Clearing_Boni[0].Value:=25;
  SoilList[i].Clearing_Result:='Swamp';
  SoilList[i].Food_M:=25;
  SoilList[i].GemStone_M:=0;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=0;
  SoilList[i].Name:='Swamp';
  i:=9; // desert (10)
  SetLength(SoilList[i].Clearing_Boni, 2);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Gem Stone';
    SoilList[i].Clearing_Boni[0].Value:=50;
  SoilList[i].Clearing_Result:='Desert';
  SoilList[i].Food_M:=0;
  SoilList[i].GemStone_M:=50;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=0;
  SoilList[i].Name:='Desert';
  i:=10; // waters (11)
  SetLength(SoilList[i].Clearing_Boni, 2);
    SoilList[i].Clearing_Boni[0].Ressource.Name:='Food';
    SoilList[i].Clearing_Boni[0].Value:=400;
  SoilList[i].Clearing_Result:='Swamp';
  SoilList[i].Food_M:=75;
  SoilList[i].GemStone_M:=0;
  SoilList[i].Gold_M:=0;
  SoilList[i].Material_M:=0;
  SoilList[i].Name:='Waters';

  // MapList  [<demo map> <demo map large>]

  i:=0;
  setLength(MapList, 2);
  MapList[i].Name:='Demo Map';
  MapList[i].Map_Length:=12;
  setLength(MapList[i].Field, MapList[i].Map_Length);

  for i:=0 to MapList[0].Map_Length-1 do begin
    MapList[0].Field[i].Garnision.Category.Name:='nothing';
  end;
  i:=0;
  addSoil(i, 0,1);
  addSoil(i, 1,2);
  addSoil(i, 2,3);
  addSoil(i, 3,4);
  addSoil(i, 4,5);
  addSoil(i, 5,6);
  addSoil(i, 6,7);
  addSoil(i, 7,8);
  addSoil(i, 8,9);
  addSoil(i, 9,10);
  addSoil(i,10,11);
  addSoil(i,11,1);

  ///////////////////////////////////////
  i:=1;
  MapList[i].Name:='Demo Map Large';
  MapList[i].Map_Length:=23;
  setLength(MapList[i].Field, MapList[i].Map_Length);

  for i:=0 to MapList[1].Map_Length-1 do begin
    MapList[1].Field[i].Garnision.Category.Name:='nothing';
  end;
  i:=1;
  addSoil(i, 0,1);
  addSoil(i, 1,2);
  addSoil(i, 2,8);
  addSoil(i, 3,4);
  addSoil(i, 4,6);
  addSoil(i, 5,5);
  addSoil(i, 6,1);
  addSoil(i, 7,11);
  addSoil(i, 8,9);
  addSoil(i, 9,3);
  addSoil(i,10,8);
  addSoil(i,11,2);
  addSoil(i,12,10);
  addSoil(i,13,10);
  addSoil(i,14,5);
  addSoil(i,15,6);
  addSoil(i,16,7);
  addSoil(i,17,11);
  addSoil(i,18,9);
  addSoil(i,19,7);
  addSoil(i,20,3);
  addSoil(i,21,4);
  addSoil(i,22,1);


  // PropList  [<Wonder> <Market>]

  setLength(PropList,2);
  i:=0; // Wonder (1)
  PropList[i].Name:='Wonder';
  PropList[i].EffectID:='wnd1';
  i:=1; // Market (2)
  PropList[i].Name:='Market';
  PropList[i].EffectID:='mrkt';


  // BuildingList  [<Base> <Market Place>]

  setLength(BuildingList, 2);

  i:=0; // Base (1)
  BuildingList[i].BuildingCosts:=giveRessource(RessourceList[3],1000);
  BuildingList[i].Health:=1000;
  BuildingList[i].Name:='Base';
    setLength(BuildingList[i].Props, 1);
    BuildingList[i].Props[0]:=PropList[0];

  i:=1; // Market Place (2)
  BuildingList[i].BuildingCosts:=giveRessource(RessourceList[3],500);
  BuildingList[i].Health:=250;
  BuildingList[i].Name:='Market Place';
    setLength(BuildingList[i].Props, 1);
    BuildingList[i].Props[0]:=PropList[1];


  // CategoryList  [<Skiller> <Magican> <Warrior> <Workaholic>]

  setLength(CategoryList, 4);

  i:=0; // Skiller (1)
  with CategoryList[i] do begin
    Name:='Skiller';

    Health:=100;
    Regeneration:=9;
    Stamina:=100;

    RecrutionCosts:=75;

    Intelligence:=20; // Attack against Skillers
    Strength:=16; // Attack against Magicans
    Nimbleness:=60; // Attack against Warriors
    Tactic:=40; // Attack against Workaholics

    Workforce:=0.1;
  end;

  i:=1; // Magican (2)
  with CategoryList[i] do begin
    Name:='Magican';

    Health:=80;
    Regeneration:=12;
    Stamina:=100;

    RecrutionCosts:=75;

    Intelligence:=50; // Attack against Skillers
    Strength:=16; // Attack against Magicans
    Nimbleness:=24; // Attack against Warriors
    Tactic:=40; // Attack against Workaholics

    Workforce:=0.1;
  end;

  i:=2; // Warrior (3)
  with CategoryList[i] do begin
    Name:='Warrior';

    Health:=120;
    Regeneration:=6;
    Stamina:=100;

    RecrutionCosts:=75;

    Intelligence:=20; // Attack against Skillers
    Strength:=40; // Attack against Magicans
    Nimbleness:=24; // Attack against Warriors
    Tactic:=40; // Attack against Workaholics

    Workforce:=0.1;
  end;

  i:=3; // Workaholic (4)
  with CategoryList[i] do begin
    Name:='Workaholic';

    Health:=60;
    Regeneration:=3;
    Stamina:=100;

    RecrutionCosts:=150;

    Intelligence:=10; // Attack against Skillers
    Strength:=8; // Attack against Magicans
    Nimbleness:=12; // Attack against Warriors
    Tactic:=20; // Attack against Workaholics

    Workforce:=1;
  end;


  // TroopList  [<Thief> <Wizard> <Speerman> <Bondsman>]

  setLength(TroopList, 4);

  i:=0; // Thief (1)
  with TroopList[i] do begin
    Category:=CategoryList[i];
    Health:=0;
    Regeneration:=0;
    Stamina:=0;
    RecrutionCosts:=0;
    Level:=0;
  end;

  i:=1; // Wizard (2)
  with TroopList[i] do begin
    Category:=CategoryList[i];
    Health:=0;
    Regeneration:=0;
    Stamina:=0;
    RecrutionCosts:=0;
    Level:=0;
  end;

  i:=2; // Speerman (3)
  with TroopList[i] do begin
    Category:=CategoryList[i];
    Health:=0;
    Regeneration:=0;
    Stamina:=0;
    RecrutionCosts:=0;
    Level:=0;
  end;

  i:=3; // Bondsman (4)
  with TroopList[i] do begin
    Category:=CategoryList[i];
    Health:=0;
    Regeneration:=0;
    Stamina:=0;
    RecrutionCosts:=0;
    Level:=0;
  end;
end;

procedure Tmain.addSoil(map, field, soil: Integer);
begin
  MapList[map].Field[field].Soil:=SoilList[soil-1];
end;

function Tmain.giveRessource(ressource: Tressource; ammount: integer
  ): Tres_ammount;
  var res_ammount:Tres_ammount;
begin
  res_ammount.Ressource:=ressource;
  res_ammount.Value:=ammount;
  result:=res_ammount;
end;

end.

